## polybori 0.8.3

=== SConstruct ===
# Emacs edit mode for this file is -*- python -*-




# Backward compatibility
if not 'Variables' in globals():
    Variables = Options
    BoolVariable = BoolOption

# Some hard-coded settings
pboriname = 'PolyBoRi'
try:
    versionnumber = open('versionnumber', 'r').read().rstrip() + "-0"
    (pboriversion, pborirevision) = versionnumber.split('-')[:2]
    pborifullrevision = (pborirevision.split('.') + ['0', '0', '0'])[:3]
    pborirelease = pborifullrevision[0]
except:
    pboriversion = "0.0"
    pborirevision = "0"
    pborifullrevision = ['0', '0', '0']
    pborirelease = "0"



debname = "polybori-" + pboriversion + '.' + pborirelease

import tarfile

import sys
from os import sep, path
from glob import glob

m4ri=Split("""grayflex.c permutation.c packedmatrix.c strassen.c
misc.c brilliantrussian.c trsm.c mmc.c echelonform.c pls.c pls_mmpf.c""")
m4ri=[path.join("M4RI/m4ri", m) for m in m4ri]

m4ri_inc = 'M4RI'

def ensure_dir(target, env):
    target = env.subst(target)
    if not path.exists(target):
        try:
            os.makedirs(target)
        except:
            # Maybe just a race condition occured, because two processes trixy
            # to generate the directory at the same time. (This I could ignore.)
            if not path.exists(target):
                raise RuntimeError, "Could not mkdir " + target


def pathsplit(p, rest=[]):
    (h,t) = os.path.split(p)
    if len(h) < 1: return [t]+rest
    if len(t) < 1: return [h]+rest
    return pathsplit(h,[t]+rest)

def commonpath(l1, l2, common=[]):
    if len(l1) < 1: return (common, l1, l2)
    if len(l2) < 1: return (common, l1, l2)
    if l1[0] != l2[0]: return (common, l1, l2)
    return commonpath(l1[1:], l2[1:], common+[l1[0]])

def relpath(p1, p2):
    (common,l1,l2) = commonpath(pathsplit(p1), pathsplit(p2))
    p = []
    if len(l1) > 0:
        p = [ ('..' + sep) * len(l1) ]
    p = p + l2

    if len(p) == 0:
        return ''
    return os.path.join( *p )

def env_relpath(env, path, versus):
    return relpath(env.subst(path), env.subst(versus))

Environment.relpath = env_relpath

def preprocessed_substitute(target, source, env):
    def preprocess_at(page):
        import re
        p = re.compile('@([^@\n]*) @', re.VERBOSE)
        return p.sub(r'$\1', page)
        
    substitute_install(target, source, env, preprocess=preprocess_at)
    

# Fix some paths and names
class PathJoiner(object):
    """Generates a valid path from lists of strings, with custom prefix (set at
    initialization). It also changes '/' to correct path separator.""" 
    def __init__(self, *parent):
        self.parent = path.join(*self.validpath(*parent))
    def __call__(self, *args):
        return path.join(self.parent, *self.validpath(*args))
    def validpath(self, *args):
        return [str(elt).replace('/', sep) for elt in args]

[TestsPath, PyPBPath, CuddPath, GBPath, PBPath, DocPath, BuildPath] = \
    [ PathJoiner(fdir)
      for fdir in Split("""testsuite PyPolyBoRi Cudd groebner libpolybori doc
 build""") ]

M4RIPath = PathJoiner('M4RI')
M4RIInc = PathJoiner(M4RIPath('m4ri'))

DataPath = PathJoiner(TestsPath('py/data'))

DebPath = PathJoiner('pkgs/debian')
DebInstPath = PathJoiner('debian')

RPMPath = PathJoiner('pkgs/rpm')
SpecsPath = PathJoiner(RPMPath('SPECS'))

   
# Split lists separated by colons and whitespaces
def SplitColonSep(arg):
    result = []
    for element in Split(arg):
        result += element.split(':')
    return result

def shell_output(*args):
    from subprocess import Popen, PIPE, STDOUT
    process = Popen(args, stdin=None, stdout=PIPE, stderr=STDOUT, env=os.environ)
    return process.communicate()[0].rstrip()


pyroot="pyroot/"
ipbroot = 'ipbori'
guiroot = 'gui'
cudd_name = 'pboriCudd'

[PyRootPath, IPBPath, GUIPath] = [PathJoiner(fdir) for fdir in [pyroot, ipbroot,
                                                                guiroot] ]
try:
	import SCons.Tool.applelink as applelink
except:
	pass
import os

def FinalizePermissions(targets, perm=None):
    def isdll(path):
        return 'dll' in os.path.basename(path).split(os.path.extsep)[1:]
    
    for src in targets:
        path = str(src)
        if not os.path.islink(path):
            if perm is None:
                if os.path.isdir(path):
                    perm = 040755
                else:
                    if os.access(path, os.X_OK) or isdll(path):
                        perm = 0755
                    else:
                        perm = 0644
            env.AddPostAction(src, Chmod(path, perm))
    return targets

def FinalizeExecs(targets):
    return FinalizePermissions(targets, 0755)

def FinalizeNonExecs(targets):
    return FinalizePermissions(targets, 0644)


distribute = 'distribute' in COMMAND_LINE_TARGETS

prepare_deb = 'prepare-debian' in COMMAND_LINE_TARGETS
generate_deb = 'deb' in COMMAND_LINE_TARGETS
deb_generation = prepare_deb or generate_deb
generate_rpm = 'rpm' in COMMAND_LINE_TARGETS
generate_srpm = 'srpm' in COMMAND_LINE_TARGETS
prepare_rpm = 'prepare-rpm' in COMMAND_LINE_TARGETS
rpm_generation = generate_rpm or generate_srpm or prepare_rpm


# Undocumented switches (for debugging foreign platforms)
defaultopts = Variables() # Works only from command line
defaultopts.Add('PLATFORM', "Manually set another platform (unusual)")
defaultopts.Add('TOOLS', "Manually set toolchain (unusual)", converter = Split)   

defaultenv = Environment(ENV = os.environ, options=defaultopts)

# See also: http://trac.sagemath.org/sage_trac/ticket/9872 and #6437
def detect_linker(env):
    import re
    args = env.subst('$CC').split() + ['-Wl,-v']
    if re.search("Binutils|GNU",  shell_output(*args)):
        return "gnu"

    # Non-gnu linker or linux (could be Sun or Intel linker) will return 'posix'.
    return env['PLATFORM']

def detect_compiler(env):
    import re
    args = env.subst('$CC').split() + ['-v']
    if re.search("gcc version",  shell_output(*args)):
        return "gnu"

    # Non-gnu linker or linux (could be Sun or Intel linker) will return 'posix'.
    return env['PLATFORM']

# for gentoo-prefix on OS X
def _fix_dynlib_flags(env):

    if env['PLATFORM']=="darwin":
        return "-Wl,-flat_namespace"
    return ''


def _sonameprefix(env):
    linker = detect_linker(env)
    #print linker, "linker detected!"
    if env['PLATFORM']=="darwin":
        return "-install_name @loader_path/"

    elif (env['PLATFORM'] == "sunos") and (linker == 'sunos'):
        return '-Wl,-h'

    else:
        return '-Wl,-soname,'

# dynamic module flags
def _dynmodule_flags(env):
    """Creates special flags for dynamic libraries, in particular on darwin."""
    if env['PLATFORM'] == "darwin":
        return "-Wl,-undefined -Wl,dynamic_lookup"
    else:
        return ""

def _moduleflags(env):
    if env['PLATFORM']=="darwin":
        python_absolute = shell_output("which", env.subst("$PYTHON"))
        return ["-fvisibility=hidden", "-bundle_loader", python_absolute]

    return []

def _relative_rpath(target, env):
    if not target or env['PLATFORM'] in ["darwin", "cygwin"]:
        return ''

    targetdir = os.path.dirname(env.subst(str(target)))
    libdir = BuildPath(env['DEVEL_LIB_PREFIX'].lstrip(sep))
    relative_path = '\\$$ORIGIN/' + env.relpath(targetdir, libdir)
    return [env['RPATHPREFIX'] + relative_path + env['RPATHSUFFIX'],
            '-z', 'origin']

def scons_version():
    import SCons
    return SCons.__version__.split('.')

def oldstyle_flags():
    return scons_version() < ['0','97','0']


class ExtendedVariables:
    def __init__(self, vars, defaults):
        from weakref import proxy
        vars.AddWithDefaults = self
        self.vars = proxy(vars)
        self.defaults = defaults
    def __call__(self, varname, *args, **kwds):   
        self.vars.Add(varname, *args, **kwds)
        self.vars.Add('DEFAULT_' + varname, 
                      "defaults appended to " + repr(varname),
                      self.defaults[varname])

pbori_cache_macros=["PBORI_UNIQUE_SLOTS","PBORI_CACHE_SLOTS","PBORI_MAX_MEMORY"]

def setup_env(defaultenv):

    opts = Variables('custom.py')

    ExtendedVariables(opts, defaultenv)
    
    # Define option handle, may be changed from command line or custom.py
    opts.Add('CXX', 'C++ Compiler (inherited from SCons)',
             defaultenv['CXX'])
    opts.Add('CC', 'C Compiler (inherited from SCons)',
             defaultenv['CC'])

    opts.Add('SHCXX', 
             'C++ Compiler (preparing shared libraries; inherited from SCons)',
             defaultenv['SHCXX'])
    opts.Add('SHCC', 
             'C Compiler (preparing shared libraries; inherited from SCons)',
             defaultenv['SHCC'])

    opts.Add('PYTHON', 'Python executable', "python$PROGSUFFIX")

    opts.Add('LIBPATH', 'list of library paths (colon or whitespace separated)',
             defaultenv.get('LIBPATH', []), converter = SplitColonSep)
    opts.Add('CPPPATH', 'list of include paths (colon or whitespace separated)',
             defaultenv.get('CPPPATH', []), converter = SplitColonSep)

    opts.Add('TEST_CPPPATH', 'list of include paths for tests (colon or whitespace separated)',
             '', converter = SplitColonSep)

    opts.Add('CPPDEFINES', 'list of preprocessor defines (whitespace separated)',
             defaultenv.get('CPPDEFINES',[]) + ['PBORI_NDEBUG'], converter = Split)


    if oldstyle_flags() :
        defaultenv.Append(CCFLAGS=["-std=c99", "$M4RI_CFLAGS"])
        defaultenv.Append(CXXFLAGS=["-std=c++98", "$M4RI_CFLAGS", 
                                    "-ftemplate-depth-100"])
        for (var, help, default) in [('CCFLAGS', "C compiler flags", ["-O3"]),
                                     ('CXXFLAGS', "C++ compiler flags", ["-O3"])]:
            opts.AddWithDefaults(var, help, default, converter=Split)

    else:
        defaultenv.Append(CCFLAGS=["$M4RI_CFLAGS"])
        defaultenv.Append(CFLAGS=["-std=c99"])
        defaultenv.Append(CXXFLAGS=["-std=c++98", "-ftemplate-depth-100"])

        for (var, help, default) in [('CCFLAGS', "C/C++ compiler flags", ["-O3"]),
                                     ('CFLAGS', "C compiler flags", []),
                                     ('CXXFLAGS', "C++ compiler flags", [])]:
            opts.AddWithDefaults(var, help, default, converter=Split)


    opts.Add('M4RI_CFLAGS', "C compiler flags for M4RI", converter = Split) 


    defaultenv.Append(LINKFLAGS=['${_fix_dynlib_flags(__env__)}', 
                                 '${_relative_rpath(TARGET, __env__)}'])
    defaultenv.Append(SHLINKFLAGS=['$SONAMEFLAGS'])
    defaultenv.Append(LDMODULEFLAGS=['${_moduleflags(__env__)}'])
    defaultenv.Append(LIBS=[])

    opts.AddWithDefaults('LINKFLAGS', 
                         "Custom linker flags (e.g. '-s' for stripping)", [],
                         converter=Split)

    opts.AddWithDefaults('SHLINKFLAGS', 'Shared libraries link flags.', [],
                         converter=Split)

    opts.AddWithDefaults('LDMODULEFLAGS',
                         'Dynamic module compile flags', [], converter=Split)

    for flag in Split("""SHCCFLAGS SHCFLAGS SHCXXFLAGS FRAMEWORKS"""):
        if defaultenv.has_key(flag):
            opts.AddWithDefaults(flag, "flags inherited from SCons",
                                 [], converter=Split)
        else:
            print "Flags", flag, "not in default environment!"


    opts.AddWithDefaults('LIBS', 'custom libraries needed for build', [],
                         converter = Split)
    opts.Add('GD_LIBS', 'Library gb and its dependencies (if needed)', 
             ["gd"], converter = Split)

    opts.Add('PREFIX', 'installation prefix directory', '$DESTDIR/usr/local')
    opts.Add('EPREFIX','executables installation prefix directory', '$PREFIX/bin')

    opts.Add('INSTALLDIR', 'end user installation directory',
             '$PREFIX/share/polybori')
    opts.Add('DOCDIR', 'documentation installation directory',
             '$INSTALLDIR/doc')
