=== debian/changelog ===
polybori (0.8.3-5build1) wily; urgency=medium

  * No-change rebuild using boost 1.58.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 12:55:18 +0000

polybori (0.8.3-5) unstable; urgency=medium

  [ Julien Puydt ]
  * Made the -dev package depend on libboost-dev. (Closes: #780570)

  [ Tobias Hansen ]
  * Made libpolybori-dev depend on libgd-dev, libpng12-dev and libm4ri-dev
    since they are referenced in the pkg-config file.
  * Made libpolybori-groebner-dev depend on libpolybori-dev (same reason).

 -- Tobias Hansen <thansen@debian.org>  Tue, 17 Mar 2015 22:13:55 +0100

polybori (0.8.3-4) unstable; urgency=medium

  * Modified the patch for clean pkg-config files. (Closes: #751098)
  * Pushed Standards-Version up.

 -- Julien Puydt <julien.puydt@laposte.net>  Wed, 04 Feb 2015 23:38:21 +0100

polybori (0.8.3-3) unstable; urgency=low

  * Tests still failed on ia64, fix it for real.
  * Try a workaround for failing testsuite on hurd due to
    problems with rpath.

 -- Tobias Hansen <thansen@debian.org>  Mon, 04 Nov 2013 22:49:54 +0100

polybori (0.8.3-2) unstable; urgency=low

  * Protect CErrorInfo::text() against invalid array access.
    The missing check caused failing tests on ia64 and alpha.

 -- Tobias Hansen <thansen@debian.org>  Sun, 03 Nov 2013 22:27:53 +0100

polybori (0.8.3-1) unstable; urgency=low

  * Add myself to Uploaders with ack from Alexander Dreyer.
  * Upload to unstable.
  * polybori-doc breaks and replaces libpolybori-dev (<< 0.8) because
    of file conflicts. (Closes: #717975)
  * Link with --as-needed to build on jessie.
  * Bump Standards-Version to 3.9.4.
  * Create watch file.
  * Create doc-base file.
  * Update debian/copyright.
  * Update package descriptions.

 -- Tobias Hansen <thansen@debian.org>  Sun, 03 Nov 2013 00:37:45 +0100

polybori (0.8.3-1~exp2) experimental; urgency=low

  * Added missing dependencies for test target 
  * Generate cleaner pkgconfig files (Closes: #702056)
  * Install convenience header /user/include/polybori.h (Closes: #702056)

  * debian/patch
    - 0001-Added-libraries-symlinks-to-testsuite-dependencies-t.patch (new)
      Added libraries symlinks to testsuite dependencies to ensure that
      tests can be executed (from upstream)
    - 0002-Generate-clean-.pc-files-from-upstream.patch (new)
      Generate cleaner pkgconfig files (Closes: #702056)

 -- Alexander Dreyer <adreyer@gmx.de>  Tue, 12 Mar 2013 11:49:56 +0100

polybori (0.8.3-1~exp1) experimental; urgency=low

  * Updating to recent Debian standards
    - supported by Frédéric-Emmanuel Picca <picca@debian.org>
  * Packaging of PolyBoRi 0.8 by Felix Salfelder <felix@salfelder.org>
    - new upstream release
    - expected to work with gcc-4.7

 -- Alexander Dreyer <adreyer@gmx.de>  Tue, 8 Jan 2013 09:31:12 +0100

polybori (0.5~rc1-2.1) unstable; urgency=low

  * Non-maintainer upload. Thanks to Kumar Appaiah for the initial patch.
  * debian/control:
    - Add ‘XB-Python-Version: ${python:Version}’, as required by python-central.
    - Tighten internal package dependencies.
  * debian/*.install:
    - Stop referring to particular versions of Python in debian/*.install
      (closes: #557293).
  * debian/rules:
    - Use correct values for RELATIVEPYPREFIX variable.
    - Pass name of Python-versioned Boost library to scons.
  * debian/patches/link-with-versioned-boost.diff:
    - Link to a correct version of Boost library.

 -- Jakub Wilk <ubanus@users.sf.net>  Sat, 09 Jan 2010 21:53:54 +0100

polybori (0.5~rc1-2) unstable; urgency=low

  * Boost 1.39 has removed the "-mt" suffix, so revert the previous change
    (and update the build dependency to 1.39) (Closes: #545608).

 -- Tim Abbott <tabbott@mit.edu>  Fri, 18 Sep 2009 19:30:17 -0400

polybori (0.5~rc1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS with current boost (Closes: #530478). As explained by Steve
    M. Robbins, single- and multi-threaded variants got dropped, only mt
    variants are available as of 1.37.0, suffixed with “-mt”. Since the
    previous filenames aren't specified, make sure a “modern” version of
    boost headers are used, bumping the versioned build dependency from
    “>= 1.33” to “>= 1.37”, and tweak SConstruct to use “boost_python-mt”
    instead of “boost_python” for the LIBS variable, using the following
    patch:
     - 01-fix-ftbfs-with-new-boost.diff

 -- Cyril Brulebois <kibi@debian.org>  Thu, 02 Jul 2009 17:26:00 +0200

polybori (0.5~rc1-1) unstable; urgency=low

  * Initial release to Debian (Closes: #480077)

 -- Tim Abbott <tabbott@mit.edu>  Tue, 08 Jul 2008 19:04:16 -0400
