=== debian/control ===
Source: polybori
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org> 
Uploaders: Alexander Dreyer <adreyer@gmx.de>,
           Felix Salfelder <felix@salfelder.org>,
           Tobias Hansen <thansen@debian.org>,
           Julien Puydt <julien.puydt@laposte.net>
Section: math
Priority: extra
Build-Depends: debhelper (>= 9),
               scons,
               libboost-dev,
               libboost-python-dev,
               libboost-test-dev,
               libm4ri-dev (>= 20120613),
               python-all-dev,
               libgd2-xpm-dev,
               libjpeg-dev
Build-Depends-Indep: doxygen,
                     dvipng,
                     tex4ht,
                     texlive-fonts-recommended,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/polybori.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/polybori.git
Homepage: http://polybori.sourceforge.net/
X-Python-Version: >= 2.6

Package: polybori
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ipython,
         python-polybori (= ${binary:Version}),
         ${python:Depends}
Provides: polybori
Description: polynomials over Boolean Rings, custom ipython shell
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi's shell ipbori.

Package: polybori-gui
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python-qt4,
         python-polybori (= ${binary:Version}),
         ${python:Depends}
Description: polynomials over Boolean Rings, GUI
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi's PolyGUI.

Package: python-polybori
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpolybori-0.8-3 (= ${binary:Version}),
         libpolybori-groebner-0.8-3 (= ${binary:Version}),
         ${python:Depends}
Description: polynomials over Boolean Rings, Python module
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi Python module.

Package: libpolybori-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libpolybori-0.8-3 (= ${binary:Version}),
         libboost-dev,
         libgd-dev,
         libpng12-dev,
         libm4ri-dev
Description: polynomials over Boolean Rings, core development files
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi core development files.

Package: libpolybori-0.8-3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: polybori-doc (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: polynomials over Boolean Rings, shared library
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi shared library libpolybori.

Package: libpolybori-0.8-3-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: ${misc:Depends},
         libpolybori-0.8-3 (= ${binary:Version})
Description: debug symbols for libpolybori-0.8-3 
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the debugging symbols of PolyBoRi's shared libraries.

Package: libpolybori-groebner-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libpolybori-groebner-0.8-3 (= ${binary:Version}),
         libpolybori-dev
Breaks: libpolybori-dev (<< 0.8)
Replaces: libpolybori-dev (<< 0.8)
Description: development files for libpolybori-groebner
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the development files for libpolybori-groebner.

Package: libpolybori-groebner-0.8-3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libpolybori-0.8-3 (= ${binary:Version})
Suggests: polybori-doc (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Breaks: libpolybori (<< 0.8)
Replaces: libpolybori (<< 0.8)
Description: computer algebra routines of PolyBoRi
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi shared library libpolybori_groebner.

Package: libpolybori-groebner-0.8-3-dbg
Architecture: any
Multi-Arch: same
Section: debug
Depends: ${misc:Depends},
         libpolybori-groebner-0.8-3 (= ${binary:Version})
Description: debug symbols for libpolybori-groebner-0.8-3
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the debugging symbols of PolyBoRi's shared library 
 libpolybori-groebner.

Package: polybori-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: libpolybori-dev (<< 0.8)
Replaces: libpolybori-dev (<< 0.8)
Description: polynomials over Boolean Rings, documentation
 The core of PolyBoRi is a C++ library, which provides high-level data
 types for Boolean polynomials and monomials, exponent vectors, as
 well as for the underlying polynomial rings and subsets of the
 powerset of the Boolean variables. As a unique approach, binary
 decision diagrams are used as internal storage type for polynomial
 structures. On top of this C++-library a Python interface
 is provided. This allows parsing of complex polynomial systems, as well
 as sophisticated and extendable strategies for Groebner base
 computation. PolyBoRi features a powerful reference implementation
 for Groebner basis computation.
 .
 This package contains the PolyBoRi documentation.
