=== debian/watch ===
version=3
http://sf.net/polybori/polybori-([0-9.]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
